#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <aitcfg.h>
#include <aitpwd.h>


int main()
{
	pwd_root_t ddd, db;
	const struct tagUser *u;
	char str[256];
	int ret = 0;

	if (cfgLoadPasswd("test.pwd", &db)) {
		printf("Error #%d - %s\n", cfg_GetErrno(), cfg_GetError());
		return 1;
	}

	/* unit test find */
	u = cfg_findPasswdBy(&db, PWD_CRIT_UID, 0);
	printf("cfg_findPasswdBy %p UID 0 User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_findPasswdBy(&db, PWD_CRIT_UID, 444);
	printf("cfg_findPasswdBy %p UID 444 User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_findPasswdBy(&db, PWD_CRIT_UID, 99999);
	printf("cfg_findPasswdBy %p UID 99999\n", u);

	u = cfg_findPasswdBy(&db, PWD_CRIT_GID, 0);
	printf("cfg_findPasswdBy %p GID 0 User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_findPasswdBy(&db, PWD_CRIT_GID, 20);
	printf("cfg_findPasswdBy %p GID 20 User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_findPasswdBy(&db, PWD_CRIT_GID, 99999);
	printf("cfg_findPasswdBy %p GID 99999\n", u);

	u = cfg_findPasswdBy(&db, PWD_CRIT_NAME, "user_l");
	printf("cfg_findPasswdBy %p NAME user_l User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_findPasswdBy(&db, PWD_CRIT_NAME, "aa");
	printf("cfg_findPasswdBy %p NAME aa User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_findPasswdBy(&db, PWD_CRIT_NAME, NULL);
	printf("cfg_findPasswdBy %p NAME NULL\n", u);
	u = cfg_findPasswdBy(&db, PWD_CRIT_NAME, "");
	printf("cfg_findPasswdBy %p NAME \"\"\n", u);

	/* get */
	u = cfg_getPasswd(&db, PWD_CRIT_UID, 0);
	printf("cfg_getPasswd %p UID 0 User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_getPasswd(&db, PWD_CRIT_UID, 444);
	printf("cfg_getPasswd %p UID 444 User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_getPasswd(&db, PWD_CRIT_UID, 99999);
	printf("cfg_getPasswd %p UID 99999\n", u);

	u = cfg_getPasswd(&db, PWD_CRIT_NAME, "user_l");
	printf("cfg_getPasswd %p NAME user_l User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_getPasswd(&db, PWD_CRIT_NAME, "aa");
	printf("cfg_getPasswd %p NAME aa User=%s %u:%u\n", u, AIT_GET_STR(&u->usr_name), 
			AIT_GET_U32(&u->usr_uid), AIT_GET_U32(&u->usr_gid));
	u = cfg_getPasswd(&db, PWD_CRIT_NAME, NULL);
	printf("cfg_getPasswd %p NAME NULL\n", u);
	u = cfg_getPasswd(&db, PWD_CRIT_NAME, "");
	printf("cfg_getPasswd %p NAME \"\"\n", u);

	printf("\n----------\n");

	/* unit test set */
	printf("cfg_setPasswd %d\n", cfg_setPasswd(&db, 4, "use", "alabala", 101, 4, 
				NULL, 0, 0, NULL, NULL, NULL));
	printf("cfg_setPasswd %d\n", cfg_setPasswd(&db, 3, "use", "alabala", 101, 3, 
				NULL, 0, 0, NULL, NULL, NULL));
	printf("cfg_setPasswd %d\n", cfg_setPasswd(&db, 3, "user_l", "pliok", 999, 3, 
				NULL, 0, 0, NULL, NULL, NULL));
	printf("cfg_setPasswd %d\n", cfg_setPasswd(&db, 2, "use1", "WC_00", 0, 0, 
				NULL, 0, 0, NULL, NULL, NULL));
	printf("cfg_setPasswd %d\n", cfg_setPasswd(&db, 0, "USE1", "WC_00", 10000, 20, 
				NULL, 0, 0, "TEST for use", "/home/USE1", "/bin/sh"));
	printf("cfg_setPasswd %d\n", cfg_setPasswd(&db, 0, "USE2", "WC_!!", 10001, 20, 
				NULL, 0, 0, "TEST for use", "/home/USE2", NULL));

	printf("\n----------\n");

	/* unit test unset */
	u = cfg_getPasswd(&db, PWD_CRIT_NAME, "ttt");
	printf("-> user=%s %u:%u \"%s\"\n", AIT_GET_STR(&u->usr_name), 
			(u_int) AIT_RAW(&u->usr_uid), (u_int) AIT_RAW(&u->usr_gid), 
			AIT_GET_LIKE(&u->usr_realm, char*));
	printf("unset %d\n", cfg_unsetPasswd(&db, PWD_CRIT_NAME, "ttt"));
	printf("unset %d\n", cfg_unsetPasswd(&db, PWD_CRIT_NAME, "tttZZZ"));
	printf("unset %d\n", cfg_unsetPasswd(&db, PWD_CRIT_NAME, "ttt"));

	printf("\n----------\n");

	cfgWritePasswd(stdout, &db);

	printf("\n----------\n");

	if (!(u = cfgAuthPasswd(&db, "user_l", "000")))
		printf("Access denied! user_l\n");
	else
		printf("Access granted - user found %p %s uid=%u:%u\n", u, AIT_GET_STR(&u->usr_name), 
				(u_int) AIT_RAW(&u->usr_uid), (u_int) AIT_RAW(&u->usr_gid));
	if (!(u = cfgAuthPasswd(&db, "BRYMMMM", "111222")))
		printf("Access denied! BRYMMMM\n");
	else
		printf("Access granted - user found %p %s uid=%u:%u\n", u, AIT_GET_STR(&u->usr_name), 
				(u_int) AIT_RAW(&u->usr_uid), (u_int) AIT_RAW(&u->usr_gid));
	if (!(u = cfgAuthPasswd(&db, "aa", "bb")))
		printf("Access denied! aa\n");
	else
		printf("Access granted - user found %p %s uid=%u:%u\n", u, AIT_GET_STR(&u->usr_name), 
				(u_int) AIT_RAW(&u->usr_uid), (u_int) AIT_RAW(&u->usr_gid));

	if (cfgCreatePasswd("test4e.pwd", &db)) {
		printf("Error #%d - %s\n", cfg_GetErrno(), cfg_GetError());
		return 2;
	}

	cfgUnloadPasswd(&db);
	return 0;
}
